/***************************************************************

*              Interfaccia Micro-GT mini V2.0                  *

*                       V1.0                                   *

*                 Marco Visentini                              *

*              Piattaforma Micro-GT IDE                        *

*                  Mplab X & V8.50                             *

*               Compiler Hitech c16                            *

****************************************************************/



#define _LEGACY_HEADERS  // permette di acquisire la sintassi dei compilatori precedenti

#include<pic.h>
#include"Delay.h"
#include"settaggi.h"


__CONFIG (HS & WDTEN & PWRTDIS & BORDIS & LVPDIS & DUNPROT & WRTEN & DEBUGDIS & UNPROTECT);//Fuses



void Selezionare();

char r1=0;
char r2=0;
char r3=1;
char marco=0;
unsigned char incr;  // risoluzione
extern void Par_ser(void);


unsigned char C1,C2,C3,C4,RxPos,TxPos,Flags;
bit pc=0;
bit pc1=0;


void main(){
	settaggi();
        

while(1){

 Par_ser();
 if (Flags==1) {
     //Par_ser();
              
               
    }     
      
 } //CLRWDT();
}


void interrupt SerChar(void)    //prototipo ricezione
{
  if (RCREG==0x40 | RxPos > 6)  //se arriva la chiocciola dimensiona la stringa
   {
   C1=0,C2=0,C3=0,C4=0;		//azzero la stringa
   RxPos=0,Flags=0; 
   }
  if (RxPos==1) {C1=RCREG;pc1=1;}
    //ricezione della stringa comandi
  if (RxPos==2) C2=RCREG;
  if (RxPos==3) C3=RCREG;
  if (RxPos==4) C4=RCREG;
  if ((RxPos==5) && (RCREG==0x0d)) Flags=1; // <CR> terminator
  RxPos++;
}



void
Par_ser(void)		       // Analisi comandi
{

    if ((C1==0x41)&&(pc1==1))  {         RB0=!RB0;              pc1=0;
     if(RB0==1){
         
      
  
      TXREG = 'A';
      
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);

      }
      if(RB0==0){

      TXREG = 'I';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(1000);
   
     }
        }   //carattere A e I

    if ((C1==0x42)&&(pc1==1))  {         RB1=!RB1;              pc1=0;
     if(RB1==1){
   

      TXREG = 'B';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);
     }

      if(RB1==0){
    

      TXREG = 'L';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);
      }
       
    }   //carattere B e L



    if ((C1==0x43)&&(pc1==1))  {         RB2=!RB2;              pc1=0;
     if(RB2==1){
      TXREG = 'C';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);
      
     }
      if(RB2==0){

      TXREG = 'M';
      TXREG = '\r';
      TXREG = '\n'; 
      DelayMs(100);

     }
    }   //carattere C e M

    if ((C1==0x44)&&(pc1==1))  {         RB3=!RB3;              pc1=0;
     if(RB3==1){

      TXREG = 'D';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);
     
      }
     if(RB3==0){
 
      
      TXREG = 'N';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);

     }
    
    
    
    
    }   //carattere D e N


    if ((C1==0x45)&&(pc1==1))  {         RB4=!RB4;              pc1=0;

    if(RB4==1){

      TXREG = 'E';
      TXREG = '\r';
      TXREG = '\n';
       DelayMs(100);
 
     }
      if(RB4==0){

      TXREG = 'O';
      TXREG = '\r';
      TXREG = '\n';
       DelayMs(100);

     }
    }   //carattere E e O

    if ((C1==0x46)&&(pc1==1))  {         RB5=!RB5;              pc1=0;
         if(RB5==1){

      TXREG = 'F';
      TXREG = '\r';
      TXREG = '\n';     
      DelayMs(100);



     }
         if(RB5==0){
 
      TXREG = 'P';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);


     }
    }   //carattere F e P


        if ((C1==0x47)&&(pc1==1))  {         RB6=!RB6;              pc1=0;
         if(RB6==1){

      TXREG = 'G';
      TXREG = '\r';
      TXREG = '\n';
     DelayMs(100);

     }
      if(RB6==0){

      TXREG = 'Q';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);


     }
        }   //carattere G e Q

        if ((C1==0x48)&&(pc1==1))  {         RB7=!RB7;              pc1=0;
         if(RB7==1){

      TXREG = 'H';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);

     }
             if(RB7==0){

      TXREG = 'R';
      TXREG = '\r';
      TXREG = '\n';
      DelayMs(100);

     }
        }   //carattere H e R



   if ((C1==0x54)&&(pc1==1))  {                   pc1=0;
         if(PORTB!=0){
     PORTB=0b00000000;
      TXREG = 'T';
      TXREG = '\r';
      TXREG = '\n';

     }
     }   //carattere S per Reset PORTB

  //carattere Y per Reset PORTB
}